<script lang="ts">
  import { fetchClaims, type ClaimData } from '$lib';

  type ClaimInput = {
    subject: string;
    claimant: string;
    type: string;
    kind: string;
    data: string;
    associatedClaim: string | null;
    registrationStart: string;
    registrationEnd: string | null;
    validStart: string | null;
    validEnd: string | null;
  };

  let claimInput: ClaimInput = {
    subject: 'f1b174f6-312f-4fc4-a555-641c6215a9fe',
    claimant: 'd15c856a-7b8e-404e-88cd-66009bbbef30',
    type: 'Voornaam',
    kind: 'Assertion',
    data: '{"name": "Henk", "id": "301", "note": "manual input"}',
    associatedClaim: null,
    validStart: '2001-01-01T00:00',
    validEnd: null,
    registrationStart: '2047-01-01T00:00',
    registrationEnd: null,
  };

  let operationInput: {registrationStart: string, validStart: string} = {
    registrationStart: '2047-01-01T00:00',
    validStart: '2001-01-01T00:00'
  }

  let operationClaims: ClaimInput[] = []

  function buildClaimCreate(input: ClaimInput) {
    return {
      input: {
        subject: input.subject,
        claimant: input.claimant,
        type: input.type,
        kind: input.kind,
        data: JSON.parse(input.data),
        associatedClaim: input.associatedClaim,
        registrationStart: input.registrationStart ? `${input.registrationStart}:00Z` : null,
        registrationEnd: input.registrationEnd ? `${input.registrationEnd}:00Z` : null,
        validStart: input.validStart ? `${input.validStart}:00Z` : null,
        validEnd: input.validEnd ? `${input.validEnd}:00Z` : null,
      },
    };
  }

  function postClaimInput() {
    var url = 'http://otherdevorg-claim-backend-127.0.0.1.nip.io:8080/v0/claims';

    fetch(url, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify(buildClaimCreate(claimInput)),
    })
      .then((response) => response.json())
      .then((data) => {
        console.log('Success:', data);
      })
      .catch((error) => {
        console.error('Error:', error);
      });
  }

  let overlappingClaims: ClaimData[] = [];

  async function fetchOverlappingClaims(_: string, __: string | null) {
    console.log('fetch overlapping');

    const responseData = await fetchClaims(
      claimInput.type,
      claimInput.registrationStart,
      claimInput.registrationEnd || '',
      claimInput.validStart || '',
      claimInput.validEnd || '',
    );

    overlappingClaims = responseData.data;
  }

  $: fetchOverlappingClaims(claimInput.registrationStart, claimInput.registrationEnd);

  function addToOperation() {
    operationClaims = [...operationClaims, {...claimInput}];
  }
  
  function postOperationInput() {
    var url = 'http://otherdevorg-claim-backend-127.0.0.1.nip.io:8080/v0/operation';

    var data: {registrationStart: string, validStart: string, claims: any[]} = {
      registrationStart: `${operationInput.registrationStart}:00Z`,
      validStart: `${operationInput.validStart}:00Z`,
      claims: []
    }

    for (let claim of operationClaims) {
      data.claims = [...data.claims, buildClaimCreate(claim).input]
    }

    fetch(url, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({input: data}),
    })
      .then((response) => response.json())
      .then((data) => {
        console.log('Success:', data);
      })
      .catch((error) => {
        console.error('Error:', error);
      });
  }
</script>

<svelte:head>
  <title>Claim input</title>
</svelte:head>

<form on:submit|preventDefault={postClaimInput} class="p-4">
  <div class="mb-7 grid grid-cols-3 gap-5 md:grid-cols-6">
    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="subject">
      Subject
    </label>
    <input
      id="subject"
      bind:value={claimInput.subject}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="text"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="claimant">
      Claimant
    </label>
    <input
      id="claimant"
      bind:value={claimInput.claimant}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="text"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="type">
      Type
    </label>
    <select
      id="type"
      bind:value={claimInput.type}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
    >
      <option value="Voornaam">Voornaam</option>
      <option value="Achternaam">Achternaam</option>
      <option value="Geboortedatum">Geboortedatum</option>
      <option value="Burgerservicenummer">Burgerservicenummer</option>
    </select>

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="kind">
      Kind
    </label>
    <select
      id="kind"
      bind:value={claimInput.kind}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
    >
      <option value="Assertion">Assertion</option>
      <option value="Correction">Correction</option>
      <option value="Refutation">BirthDate</option>
    </select>

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="data">
      Data
    </label>
    <textarea
      id="data"
      bind:value={claimInput.data}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      rows="3"
    />

    

    <label
      class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2"
      for="associatedClaim"
    >
      Associated claim
    </label>
    <input
      id="associatedClaim"
      bind:value={claimInput.associatedClaim}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="text"
    />

    <label
      class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2"
      for="registration-from"
    >
      Registratie start
    </label>
    <input
      id="registration-from"
      bind:value={claimInput.registrationStart}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label
      class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2"
      for="registration-to"
    >
      Registratie eind
    </label>
    <input
      id="registration-to"
      bind:value={claimInput.registrationEnd}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="valid-from">
      Validiteit start
    </label>
    <input
      id="valid-from"
      bind:value={claimInput.validStart}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label class="mb-3 inline-flex items-center font-medium text-gray-600 sm:pt-2" for="valid-to">
      Validiteit eind
    </label>
    <input
      id="valid-to"
      bind:value={claimInput.validEnd}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />
  </div>

  {#if overlappingClaims.length}
    <h2 class="mb-5 text-xl font-medium">
      Overlappende claims waarvan de registratie wordt beëindigd
    </h2>

    <ul>
      {#each overlappingClaims as claim}
        <li
          class="mb-5 whitespace-pre-wrap rounded-md bg-slate-600 p-4 font-mono text-sm text-white"
        >
          {JSON.stringify(claim, null, '  ')}
        </li>
      {/each}
    </ul>
  {/if}

  <button
    class="inline-block rounded-lg border border-blue-600 bg-blue-500 px-4 py-2.5 text-sm font-medium text-white shadow-sm hover:border-blue-700 hover:bg-blue-600 focus:outline-none focus:ring-4 focus:ring-blue-200"
    type="submit">Submit claim</button
  >
  <button on:click|preventDefault={addToOperation} 
    class="inline-block rounded-lg border border-blue-600 bg-white-500 px-4 py-2.5 text-sm font-medium text-gray shadow-sm hover:border-blue-700 hover:bg-blue-600 focus:outline-none focus:ring-4 focus:ring-blue-200"
  > Add to operation </button>
</form>


<form on:submit|preventDefault={postOperationInput} class="p-4">
  <div class="col-span-3 mb-3"></div>

  <h1> Operation: </h1>
  <div id="operationinput" class="mb-7 grid grid-cols-3 gap-4 md:grid-cols-6">  
    <label class="mb-3 inline-flex items-center text-gray-600 sm:pt-2" for="operation-registration-start">
      Registratie start:
    </label>
    <input
      id="operation-registration-start"
      bind:value={operationInput.validStart}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />

    <label class="mb-3 inline-flex items-center text-gray-600 sm:pt-2" for="operation-valid-start">
      Validiteit start:
    </label>
    <input
      id="operation-valid-start"
      bind:value={operationInput.registrationStart}
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
      type="datetime-local"
    />
    <label class="mb-3 inline-flex items-center text-gray-600 sm:pt-2" for="claim-count">
      claim count:
    </label>
    <span
      id="claim-count"
      class="form-input col-span-2 rounded-md border-slate-300 px-2.5 py-1.5 text-gray-800 focus:border-blue-500 focus:outline-none focus:ring-1 focus:ring-blue-500"
    >
      {operationClaims.length}
    </span>
    <div class="col-span-3 mb-3"></div>

    <button  
      class="inline-block rounded-lg border border-blue-600 bg-blue-500 px-4 py-2.5 text-sm font-medium text-white shadow-sm hover:border-blue-700 hover:bg-blue-600 focus:outline-none focus:ring-4 focus:ring-blue-200"
      type="submit"
    > submit operation </button>

  </div>
</form>
